using System;
using System.Windows.Forms;
using DicomObjects;

namespace Sample_Viewer_Program
{
	/// <summary>
	/// Summary description for RetrieveDialogType.
	/// </summary>
	public class RetrieveDialogType : Form
	{
		private Label label1;
		private TextBox QueryPatientName;
		private Button Query;
		private TreeView Tree;
		private Button RetrieveBTN;
		private Button ResetBTN;
		private Button CloseBTN;
		private System.ComponentModel.Container components = null;
		
		// =========================================================
		OptionsBoxType OptionsBox;
		DicomViewer viewer1;
		private GroupBox PatientIDBox;
		DicomQuery q;			
		DicomDataSetCollection res;

		// =========================================================

		public RetrieveDialogType()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.PatientIDBox = new GroupBox();
			this.Query = new Button();
			this.QueryPatientName = new TextBox();
			this.label1 = new Label();
			this.Tree = new TreeView();
			this.RetrieveBTN = new Button();
			this.ResetBTN = new Button();
			this.CloseBTN = new Button();
			this.PatientIDBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// PatientIDBox
			// 
			this.PatientIDBox.Controls.Add(this.Query);
			this.PatientIDBox.Controls.Add(this.QueryPatientName);
			this.PatientIDBox.Controls.Add(this.label1);
			this.PatientIDBox.Location = new System.Drawing.Point(16, 8);
			this.PatientIDBox.Name = "PatientIDBox";
			this.PatientIDBox.Size = new System.Drawing.Size(624, 72);
			this.PatientIDBox.TabIndex = 0;
			this.PatientIDBox.TabStop = false;
			this.PatientIDBox.Text = "Query";
			// 
			// Query
			// 
			this.Query.Location = new System.Drawing.Point(496, 24);
			this.Query.Name = "Query";
			this.Query.Size = new System.Drawing.Size(104, 32);
			this.Query.TabIndex = 2;
			this.Query.Text = "Query";
			this.Query.Click += new System.EventHandler(this.Query_Click);
			// 
			// QueryPatientName
			// 
			this.QueryPatientName.BorderStyle = BorderStyle.FixedSingle;
			this.QueryPatientName.Location = new System.Drawing.Point(280, 30);
			this.QueryPatientName.Name = "QueryPatientName";
			this.QueryPatientName.Size = new System.Drawing.Size(192, 20);
			this.QueryPatientName.TabIndex = 1;
			this.QueryPatientName.Text = "*";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(258, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Enter Patient Name. (Leave Black or * if Unknown)";
			// 
			// Tree
			// 
			this.Tree.BorderStyle = BorderStyle.FixedSingle;
			this.Tree.ImageIndex = -1;
			this.Tree.Location = new System.Drawing.Point(16, 88);
			this.Tree.Name = "Tree";
			this.Tree.SelectedImageIndex = -1;
			this.Tree.Size = new System.Drawing.Size(624, 280);
			this.Tree.TabIndex = 1;
			this.Tree.AfterExpand += new TreeViewEventHandler(this.Tree_AfterExpand);
			// 
			// RetrieveBTN
			// 
			this.RetrieveBTN.Location = new System.Drawing.Point(144, 376);
			this.RetrieveBTN.Name = "RetrieveBTN";
			this.RetrieveBTN.Size = new System.Drawing.Size(112, 40);
			this.RetrieveBTN.TabIndex = 2;
			this.RetrieveBTN.Text = "Retrieve";
			this.RetrieveBTN.Click += new System.EventHandler(this.RetrieveBTN_Click);
			// 
			// ResetBTN
			// 
			this.ResetBTN.Location = new System.Drawing.Point(280, 376);
			this.ResetBTN.Name = "ResetBTN";
			this.ResetBTN.Size = new System.Drawing.Size(112, 40);
			this.ResetBTN.TabIndex = 3;
			this.ResetBTN.Text = "Reset";
			this.ResetBTN.Click += new System.EventHandler(this.ResetBTN_Click);
			// 
			// CloseBTN
			// 
			this.CloseBTN.Location = new System.Drawing.Point(416, 376);
			this.CloseBTN.Name = "CloseBTN";
			this.CloseBTN.Size = new System.Drawing.Size(112, 40);
			this.CloseBTN.TabIndex = 4;
			this.CloseBTN.Text = "Close";
			this.CloseBTN.Click += new System.EventHandler(this.CloseBTN_Click);
			// 
			// RetrieveDialogType
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(656, 430);
			this.Controls.Add(this.CloseBTN);
			this.Controls.Add(this.ResetBTN);
			this.Controls.Add(this.RetrieveBTN);
			this.Controls.Add(this.Tree);
			this.Controls.Add(this.PatientIDBox);
			this.FormBorderStyle = FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "RetrieveDialogType";
			this.Text = "RetrieveDialogType";
			this.PatientIDBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		
		
		public void LoadPatient(OptionsBoxType o, DicomViewer v)
		{
			OptionsBox = o;
			viewer1 = v;
			ShowDialog();
		}

		private string GetDescription(DicomDataSet ds)
		{
			string s = ds.StudyDescription;
			if(string.IsNullOrEmpty(s))
			{
				s = "STUDY";
			}

			if(ds[0x8, 0x20].Exists)
			{
				s = s + " on " + ds[0x8, 0x20].Value.ToString();
			}

			return s;				  
		}
	
		// Query By Patient Name 
		private void Query_Click(object sender, EventArgs e)
		{
			q = new DicomQuery();
			DicomDataSet r;			
			int index_r;
			string[] IDs = new string[5];

			Tree.Nodes.Clear();			
			PatientIDBox.Visible = false;
			
			q.Node = OptionsBox.RemoteNode.Text;
			q.Port = Convert.ToInt32(OptionsBox.RemotePort.Text);
			q.CallingAE = OptionsBox.CallingAE.Text;
			q.CalledAE = OptionsBox.RemoteAE.Text;
			
			if (OptionsBox.PatientRoot.Checked)
			{
				q.Level = DicomObjects.Enums.QueryLevel.PATIENT;
				q.Root = DicomObjects.Enums.QueryRoot.Patient;}
			else
			{
				q.Level = DicomObjects.Enums.QueryLevel.STUDY;
				q.Root = DicomObjects.Enums.QueryRoot.Study;
			}
			
			q.Name = QueryPatientName.Text;

			res = q.Find();
			TreeNode nd;
			
			for(index_r = 0; index_r <= res.Count -1; index_r ++)
			{
				r = res[index_r];
				IDs[1] = r.PatientID;
				if(OptionsBox.PatientRoot.Checked)
				{
					nd = Tree.Nodes.Add(r.Name);
					IDs[0] = "1";
                    nd.Nodes.Add("Please wait, while the study list is being retrieved");
				}
				else
                {
					nd = Tree.Nodes.Add(r.Name + " / " + GetDescription(r));
					IDs[0] = "2";
					IDs[2] = r.StudyUID;
                    nd.Nodes.Add("Please wait, while the series list is being retrieved");
				}
				nd.Tag = IDs.Clone();
				nd.Collapse();
			}
		}

		// Send out C-GET or C-MOVE Requests to Retrieve Images
		private void RetrieveBTN_Click(object sender, EventArgs e)
		{
			string[] Tags;
			int Tag0;			
			int i;
			DicomDataSetCollection s;
			DicomDataSet returnedStatus;
			TreeNode node = Tree.SelectedNode;

			Tags = (string[])node.Tag;				
			Tag0 = Convert.ToInt32(Tags[0].ToString());

			switch(Tag0)
			{
				case 1:	// "PATIENT"
					q.PatientID = Tags[1];
					q.StudyUID = "";
					q.SeriesUID = "";
					q.InstanceUID = "";
					q.Level = DicomObjects.Enums.QueryLevel.PATIENT;
					break;
				case 2:	// "STUDY"
					q.PatientID = Tags[1];
					q.StudyUID = Tags[2];
					q.SeriesUID = "";
					q.InstanceUID = "";
					q.Level = DicomObjects.Enums.QueryLevel.STUDY;
					break;
				case 3: // "SERIES"
					q.PatientID = Tags[1];
					q.StudyUID = Tags[2];
					q.SeriesUID = Tags[3];
					q.InstanceUID = "";
					q.Level = DicomObjects.Enums.QueryLevel.SERIES;
					break;
				case 4:
					q.PatientID = Tags[1];
					q.StudyUID = Tags[2];
					q.SeriesUID = Tags[3];
					q.InstanceUID = Tags[4];
					q.Level = DicomObjects.Enums.QueryLevel.INSTANCE;
					break;
				default:
					goto case 1;
			}
				
			if(OptionsBox.CGET.Checked)
			{
				s = q.Get();
				for( i = 0; i < s.Count; i ++)
				{
                    viewer1.Images.Add(new DicomImage(s[i]));
				}
			}
			else if(OptionsBox.CMOVE.Checked)
			{
				q.Destination = OptionsBox.MoveDestination.Text;
				returnedStatus = q.Move();
				MessageBox.Show("Move Status -- " + returnedStatus[0x0000,0x0900].Value.ToString());
			}
			Close();
		}

		// Reset the Query TreeNode
		private void ResetBTN_Click(object sender, EventArgs e)
		{
			Tree.Nodes.Clear();
			PatientIDBox.Visible = true;
		}

		// Close the Query/Retrieve Dialog
		private void CloseBTN_Click(object sender, EventArgs e)
		{
			Close();
		}

		private void Tree_AfterExpand(object sender, TreeViewEventArgs e)
		{
			string[] Tags;
			int Tag0;
			string[] IDs = new string[6];
			int i;
			string s;
			int index_r;
			DicomDataSet r;
			TreeNode nd;

			Tags = (string[])e.Node.Tag;				
			Tag0 = Convert.ToInt32(Tags[0].ToString());
			for(i = 1; i <= Tag0; i++)
			{
				IDs[i] = Tags[i];
			}
			IDs[0] = (Tag0 + 1).ToString();
			
			switch(Tag0)
			{
				case 1: // "PATIENT"
					q.Level = DicomObjects.Enums.QueryLevel.STUDY;
					q.PatientID = Tags[1];
					q.StudyUID = "";
					q.SeriesUID = "";
					q.InstanceUID = "";
					res = q.Find();                    
					e.Node.Nodes.Clear();

                    for (index_r = 0; index_r < res.Count; index_r++)
					{
						r = res[index_r];
						s = GetDescription(r);
						nd = e.Node.Nodes.Add(s);
						IDs[2] = r.StudyUID;
						nd.Tag = IDs.Clone();
						nd.Nodes.Add("Please wait, while the series list is retrieved");
						nd.Collapse();
					}
					break;
				case 2: // "STUDY"
					q.Level = DicomObjects.Enums.QueryLevel.SERIES;
					q.PatientID = Tags[1];
					q.StudyUID = Tags[2];
					q.SeriesUID = "";
					q.InstanceUID = "";
					res = q.Find();
					e.Node.Nodes.Clear();

                    for (index_r = 0; index_r < res.Count; index_r++)
					{
						r = res[index_r];
						s = r.SeriesDescription;
						if (s == "")
							s = "**SERIES**";
						nd = e.Node.Nodes.Add(s);
						IDs[3] = r.SeriesUID;
						nd.Tag = IDs.Clone();
						nd.Nodes.Add("Please wait, while the Image list is retrieved");
						nd.Collapse();
					}
					break;
				case 3: // "SERIES"
                    q.Level = DicomObjects.Enums.QueryLevel.INSTANCE;
					q.PatientID = Tags[1];
					q.StudyUID = Tags[2];
					q.SeriesUID = Tags[3];
					q.InstanceUID = "";
					res = q.Find();

					e.Node.Nodes.Clear();
                    for (index_r = 0; index_r < res.Count; index_r++)
					{
	                    r = res[index_r];
		                s = r.InstanceUID;
			            nd = e.Node.Nodes.Add(s);
				        IDs[4] = r.InstanceUID;
						nd.Tag = IDs.Clone();
					}
					break;
				case -1: // case -1/-2/-3, Do nothing, already retrieved	
				case -2:
				case -3:
					break;
				default:
					MessageBox.Show("Invalid Level");
					break;
			}
			Tags[0] = (-Tag0).ToString();
		}
	}
}
